#include <stdio.h>

/*!
 * @defgroup TEST This is a test.
 **/

#ifdef ENUMIFY
#undef ENUMIFY
#endif

#define NAMES ENUMIFY(RED) \
              ENUMIFY(GREEN) \
              ENUMIFY(BLUE)

#define ENUMIFY(x) x,

/*!
 * This is an enumeration created with a preprocessor trick!
 * 
 * @ingroup TEST
 **/
enum color { NAMES 
             COUNT  /**< This is a count of the number of entries in this enum. */
	       };

#undef ENUMIFY

#define ENUMIFY(x) #x,

const char * const color_name[] = { NAMES };

int main( void ) 
   { 
   printf( "The color is %s.\n", color_name[ RED ]);  
   printf( "There are %d colors.\n", COUNT ); 

   return 0;
   }
